unit TBfThStrm;
{
Implements basic fuctionality of bufferred read/write.
Doesn't make anything easy! :o)
}
{$IFDEF FPC}
   // FPC options modes:
{$MODE OBJFPC}
{$SMARTLINK ON}
{$ENDIF}

interface

uses Classes,
  Windows;

const
//  ReadBufferSize = 4194304;
//  WriteBufferSize = 4194304;
  ReadBufferSize = 2097152;
  WriteBufferSize = 2097152;
//  ReadBufferSize = 1048576;
//  WriteBufferSize = 1048576;


(*  MinimalBufferSize: Cardinal = 128; {2 kilobytes}
      {If file size is smaller than MinimalBufferSize then create tryes to
       allocate buffer with size MinimalBufferSize}
  MaximalBufferSize: Cardinal = 1048576; {4 kilobytes}
//  MaximalBufferSize: Cardinal = 8388608 {4194304}; {4 megabytes}
      {Maximal size of buffer}

  MaximalDepth: Cardinal = 8;
      {Maximal number of recursion while trying to allocate buffer}*)


type

  PFileStream = ^TFileStream;
  PMemoryStream = ^TMemoryStream;

  TBufferedStreamReadThread = class(TThread)
   // Enables threaded file reading
  private
  protected
    Stream: PFileStream;
  public
    Position: Cardinal;
    FSize: Cardinal;

    ReadBuffer1: array[1..ReadBufferSize] of Char;
    Buffer1Pos: Integer;
    Buffer1End: Integer;

    ReadBuffer2: array[1..ReadBufferSize] of Char;
    Buffer2Pos: Integer;
    Buffer2End: Integer;

    Buffer2Read: Integer;

    constructor Create(const aStream: PFileStream);
    procedure Execute; override;
  end;

  TBufferedStreamWriteThread = class(TThread)
   // Enables threaded file writing
  private
  protected
    Stream: PFileStream;
  public
    WriteBuffer1: array[1..ReadBufferSize] of Char;
    Buffer1End: Integer;

    WriteBuffer2: array[1..ReadBufferSize] of Char;
    Buffer2End: Integer;

    Buffer2Write: Integer;

    constructor Create(const aStream: PFileStream);
    procedure Execute; override;
  end;

  TBufferedHandleReadThread = class(TThread)
   // Enables threaded file reading
  private
  protected
    Handle: THandle;
  public
    Position: Cardinal;
    FSize: Cardinal;

    ReadBuffer1: array[1..ReadBufferSize] of Char;
    Buffer1Pos: dword;
    Buffer1End: dword;

    ReadBuffer2: array[1..ReadBufferSize] of Char;
    Buffer2Pos: dword;
    Buffer2End: dword;

    Buffer2Read: Integer;

//    property ReturnValue: Integer read FReturnValue write FReturnValue;

    constructor Create(const aHandle: THandle);
    procedure Execute; override;
  end;

  TBufferedHandleWriteThread = class(TThread)
   // Enables threaded file writing
  private
  protected
    Handle: THandle;
  public
    WriteBuffer1: array[1..ReadBufferSize] of Char;
    Buffer1End: dword;

    WriteBuffer2: array[1..ReadBufferSize] of Char;
    Buffer2End: dword;

    Buffer2Write: Integer;

    constructor Create(const aHandle: THandle);
    procedure Execute; override;
  end;

(*  TBufferedFileStream = class(TFileStream)
  private
    Buffer: PChar;
    BufferPos: Cardinal;
    BytesRead: Cardinal;
    Dirty: Boolean;
    BufferSize: Cardinal;
  public
    constructor Create(const AFileName: string; Mode: Word; WantedBufferSize: Cardinal);
    destructor Destroy; override;

    function Seek(Offset: Longint; Origin: Word): Longint; override;
    procedure ResetBuffer;
    function GetNextChar(var C: Char): Boolean;
    procedure PutChar(const C: Char);

    function GetBufferSize: Cardinal;
    function FileSize: Cardinal;
  end;*)

implementation

uses
  SysUtils;

procedure TBufferedStreamReadThread.Execute;
begin
  while (not Terminated) do
  begin

    if (Position = FSize) then
    begin
      Sleep(5); //we must wait until all data are used!
    end
    else
    begin

      if (Buffer2Read = 1) and (Buffer1Pos > Buffer1End) then
      begin
        try
          Buffer1End := Stream^.Read(ReadBuffer1, SizeOf(ReadBuffer1));
        except
        end;
        Position := Stream^.Position;
        if (Buffer1End <> SizeOf(ReadBuffer1)) and (Position <> FSize) then
          raise
            Exception.Create('Error reading file!');
        Buffer1Pos := 1;
        Buffer2Read := 2;
      end
      else
        if (Buffer2Read = 2) and (Buffer2Pos > Buffer2End) then
        begin
          try
            Buffer2End := Stream^.Read(ReadBuffer2, SizeOf(ReadBuffer2));
          except
          end;
          Position := Stream^.Position;
          if (Buffer2End <> SizeOf(ReadBuffer2)) and (Position <> FSize) then
            raise
              Exception.Create('Error reading file!');
          Buffer2Pos := 1;
          Buffer2Read := 1;
        end
        else
          Sleep(5); //nobody wants our data :o(
    end;
  end;
end;
// Resume;


constructor TBufferedStreamReadThread.Create(const aStream: PFileStream);
begin
  Stream := aStream;
  Buffer2Read := 1;
  FSize := Stream^.Size;
  Position := Stream^.Position;
  Buffer1End := SizeOf(ReadBuffer1);
  Buffer1Pos := Buffer1End + 1;
  Buffer2End := SizeOf(ReadBuffer2);
  Buffer2Pos := Buffer2End + 1;
  inherited Create(True);
  FreeOnTerminate := True;
end;

procedure TBufferedStreamWriteThread.Execute;
begin
  while (not Terminated) or (Buffer2End > 0) or (Buffer1End > 0) do
  begin
    if (Buffer2Write = 1) and (Buffer1End > 0) then
    try
      Stream^.Write(WriteBuffer1, Buffer1End);
      Buffer1End := 0;
      Buffer2Write := 2;
    except
      raise
        Exception.Create('Error writing file!');
    end
    else
      if (Buffer2Write = 2) and (Buffer2End > 0) then
      try
        Stream^.Write(WriteBuffer2, Buffer2End);
        Buffer2End := 0;
        Buffer2Write := 1;
      except
        raise
          Exception.Create('Error writing file!');
      end
      else
        Sleep(5); //nobody wants to write data :o(
  end;
end;
// Resume;


constructor TBufferedStreamWriteThread.Create(const aStream: PFileStream);
begin
  Stream := aStream;
  Buffer2Write := 1;
  Buffer1End := 0;
  Buffer2End := 0;
  inherited Create(True);
  FreeOnTerminate := True;
end;


{
function TBufferedFileStream.FileSize: Cardinal;
begin
  Result := GetFileSize(Handle, nil);
end;

function TBufferedFileStream.GetBufferSize: Cardinal;
begin
  Result := BufferSize;
end;

(*------------------------------------------------------------------------------
  Create
  ------
  Only resets the buffer after object is constructed. *)

constructor TBufferedFileStream.Create(const AFileName: string; Mode: Word; WantedBufferSize:
  Cardinal);
var
  Depth: Cardinal;

  function TryBuffer: Boolean;
  begin
    ;
    Result := True;
    Inc(Depth);
    if BufferSize = 1 then
    begin
      Result := False;
      Exit;
    end;
    if Depth > MaximalDepth then
    begin
      Result := False;
      Exit;
    end;
    try
      GetMem(Buffer, BufferSize);
    except
      BufferSize := BufferSize shr 1;
      Result := TryBuffer;
    end;
  end;

begin
  inherited Create(AFileName, Mode);

  Dirty := False;
  //Create buffer:
  if WantedBufferSize = 0 then
    BufferSize := GetFileSize(Handle, nil)
  else
    BufferSize := WantedBufferSize;
  if BufferSize < MinimalBufferSize then
    BufferSize := MinimalBufferSize;
  if BufferSize > MaximalBufferSize then
    BufferSize := MaximalBufferSize;
  Depth := 0;
  if not (TryBuffer) then
  begin
    BufferSize := 0;
    Buffer := nil;
  end;
  ResetBuffer;
end;

(*------------------------------------------------------------------------------
  Destroy
  -------
  Commits any data and destroys object. *)

destructor TBufferedFileStream.Destroy;
begin
  ResetBuffer;
  FreeMem(Buffer, BufferSize);
  inherited Destroy;
end;

(*------------------------------------------------------------------------------
  ResetBuffer
  -----------
  Writes any information that has not  been committed.

  Will set BufferPos and BytesRead to values that will force a file read the
  next time GetNextChar is called *)

procedure TBufferedFileStream.ResetBuffer;
begin
  if Dirty then
  begin
    Write(Buffer^, BufferPos);
    Dirty := False;
  end;
  BufferPos := BufferSize;
  BytesRead := BufferSize;
end;

(*------------------------------------------------------------------------------
  Seek
  ----
  Is not smart enough to determine whether the destination is within the buffer
  because it does not maintain information about the buffer's position relative
  to the beginning of the stream.

  It simply resets the current buffer, so the stream will perform a file read
  after every seek. *)

function TBufferedFileStream.Seek(Offset: Longint; Origin: Word): Longint;
begin
  ResetBuffer;
  Result := inherited Seek(Offset, Origin);
end;

(*------------------------------------------------------------------------------
  GetNextChar
  -----------
  Reads the next character in the stream.
  If and end of file is reached, returns False, otherwise returns True and
  populates C with the character read.

  BufferSize characters are read from disk at a time, and when the buffer
  runs out, a new buffer is automatically read.

  Making BufferSize larger will reduce the number of reads and thus
  increase speed, but will ( of course ) consume more memory. *)

function TBufferedFileStream.GetNextChar(var C: Char): Boolean;
begin

  Result := False;
  if ((BufferPos + 1) > BytesRead) then
  begin
    if (BytesRead < BufferSize) then
      Exit
    else
    begin
      BufferPos := 0;
      BytesRead := Read(Buffer^, BufferSize);
      Result := GetNextChar(C);
    end;
  end
  else
  begin
    C := Buffer[BufferPos];
    Inc(BufferPos);
    Result := True;
  end;
end;


(*------------------------------------------------------------------------------
  PutChar
  -------
  If the buffer is full and dirty, it will be written to disk and restarted. *)

procedure TBufferedFileStream.PutChar(const C: Char);
begin
  if ((BufferPos + 1) > BufferSize) then
  begin
    ResetBuffer;
    BufferPos := 0;
  end;
  Buffer[BufferPos] := C;
  Inc(BufferPos);
  Dirty := True;
end;}

procedure TBufferedHandleReadThread.Execute;
begin
  while (not Terminated) do
  begin

    if (Position = 0) and (Buffer2Read = 1) and (Buffer1Pos > Buffer1End) then
    begin
      try
        ReadFile(Handle, ReadBuffer1, SizeOf(ReadBuffer1) shr 1, Buffer1End, nil);
      except
      end;
      Position := SetFilePointer(Handle, 0, nil, 1);
      if (Buffer1End <> (SizeOf(ReadBuffer1) shr 1)) and (Position <> FSize) then
        raise
          Exception.Create('Error reading file!');
      Buffer1Pos := 1;
      Buffer2Read := 2;
    end
    else
      if (Position = FSize) then
      begin
        Sleep(25); //we must wait until all data are used!
      end
      else
      begin
        if (Buffer2Read = 1) and (Buffer1Pos > Buffer1End) then
        begin
          try
            ReadFile(Handle, ReadBuffer1, SizeOf(ReadBuffer1), Buffer1End, nil);
          except
          end;
          Position := SetFilePointer(Handle, 0, nil, 1);
          if (Buffer1End <> SizeOf(ReadBuffer1)) and (Position <> FSize) then
            raise
              Exception.Create('Error reading file!');
          Buffer1Pos := 1;
          Buffer2Read := 2;
        end
        else
          if {(Buffer2Read = 2) and}(Buffer2Pos > Buffer2End) then
          begin
            try
              ReadFile(Handle, ReadBuffer2, SizeOf(ReadBuffer2), Buffer2End, nil);
            except
            end;
            Position := SetFilePointer(Handle, 0, nil, 1);
            if (Buffer2End <> SizeOf(ReadBuffer2)) and (Position <> FSize) then
              raise
                Exception.Create('Error reading file!');
            Buffer2Pos := 1;
            Buffer2Read := 1;
          end
          else
            Sleep(5); //nobody wants our data :o(}
      end;
  end;
end;


constructor TBufferedHandleReadThread.Create(const aHandle: THandle);
begin
  Handle := aHandle;
  Buffer2Read := 1;

  FSize := GetFileSize(Handle, nil);
  Position := SetFilePointer(Handle, 0, nil, 1);
  Buffer1End := SizeOf(ReadBuffer1);
  Buffer1Pos := Buffer1End + 1;
  Buffer2End := SizeOf(ReadBuffer2);
  Buffer2Pos := Buffer2End + 1;
  inherited Create(True);
  FreeOnTerminate := False;
end;

procedure TBufferedHandleWriteThread.Execute;
var
  WriteResult: dword;
begin
  while (not Terminated) or (Buffer2End > 0) or (Buffer1End > 0) do
  begin
    if (Buffer2Write = 1) and (Buffer1End > 0) then
    try
      WriteFile(Handle, WriteBuffer1, Buffer1End, WriteResult, nil);
      if Buffer1End <> WriteResult then
        raise
          Exception.Create('Error writing file!');
      Buffer1End := 0;
      Buffer2Write := 2;
    except
      raise
        Exception.Create('Error writing file!');
    end
    else
      if {(Buffer2Write = 2) and}(Buffer2End > 0) then
      try
        WriteFile(Handle, WriteBuffer2, Buffer2End, WriteResult, nil);
        if Buffer2End <> WriteResult then
          raise
            Exception.Create('Error writing file!');

        Buffer2End := 0;
        Buffer2Write := 1;
      except
        raise
          Exception.Create('Error writing file!');
      end
      else
        Sleep(5); //nobody wants to write data :o(}
  end;
end;


constructor TBufferedHandleWriteThread.Create(const aHandle: THandle);
begin
  Handle := aHandle;
  Buffer2Write := 1;
  Buffer1End := 0;
  Buffer2End := 0;
  inherited Create(True);
  FreeOnTerminate := False;
end;


end.